
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Random;

/**
 * Bowser's Army
 *
 * For the UMD High School Programming Contest, 2009.
 * @author Chau-Wen Tseng
 */
public class TeamGen {
	// static final String koopaType[] = {"lakitu", "magikoopa", "paratroopa", "spiny", "troopa"} ;
	// static final String koopaType[] = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"} ;
	// static final String koopaType[] = {"a", "b", "c", "d", "e", "f", "g"} ;
	// static final String koopaType[] = {"paratroopa", "spiny", "troopa"} ;
	static final String koopaType[] = {"Lakitu", "Magikoopa", "Paratroopa", "Spiny", "Troopa", "Goomba", "HammerBro", "DryBones", "BuzzyBeetle", "BulletBill", "ChainChomp", "MontyMole", "PiranhaPlant", "Thwomp", "Wiggler"} ;

	
	static final int numKoopaTypes = koopaType.length;
	static int koopas[] = new int [numKoopaTypes];
	static int allKoopas;

	static final String leaderType[] = 
	{"Team", "Sergeant", "Lieut", "Capt", "Major", "Colonel", "General", "Marshal", "BowserJr", "Bowser"} ;

	static final int maxTeams = 2000;

	static int numTeams = 0;
	static int numLeaders = 0;

	static int teamID[] = new int [maxTeams];
	static int members[][] = new int [maxTeams][numKoopaTypes];
	static int teamLeader[] = new int [maxTeams];
	static double power[] = new double [maxTeams];

	public static void main(String[] args) throws Exception {
		try{
			String logName;
			PrintStream flog;

			logName = "01.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(2);
			flog.close();

			logName = "02.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(3);
			flog.close();

			logName = "03.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(4);
			flog.close();

			logName = "04.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(32);
			flog.close();

			logName = "05.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(33);
			flog.close();

			logName = "06.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(127);
			flog.close();

			logName = "07.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(128);
			flog.close();

			logName = "08.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(511);
			flog.close();

			logName = "09.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(512);
			flog.close();
			
			logName = "10.in";
			flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setOut(new PrintStream(flog));
			genTeam(1111);
			flog.close();

		} catch (Exception e) {
			System.err.println("Caught exception: " + e);
			e.printStackTrace();
			System.err.println();
		}
	}

	public static void genTeam(int numTeams) throws Exception {
		Random r = new Random(0);
		int f = r.nextInt(numKoopaTypes);

		// generate member types
		// System.out.println("MEMBERS");
		for (int i = 0; i < numKoopaTypes; i++) {
			System.out.print(koopaName(i) + " ");
		}
		System.out.println();

		// System.out.println("TEAMS");
		System.out.println(numTeams);
		for (int i = 1; i <= numTeams; i++) {
			f = r.nextInt(numKoopaTypes);
			System.out.print (leaderType[0]+ i);
			int teamSize = 4;
			// int teamSize = 3 + r.nextInt(3); 	// between 3-6 members
			for (int k = 0; k < teamSize; k++) {
				// f = r.nextInt(numKoopaTypes);
				System.out.print(" " + koopaName(f));
			}
			System.out.println();
		}

		// generate leaders
		// System.out.println("ORGANIZATION");

		StringBuffer str = new StringBuffer();
		int assignments = 0;
		
		int assign = numTeams/2;
		boolean extra = (numTeams % 2) == 1;
		int lvl = 1;
		while ((assign > 0) && (lvl < leaderType.length-1)) {
			assignments += assign;
			for (int i = 0 ; i < assign; i++) {
				int t1 = 2*i+1;
				int t2 = 2*i+2;
				str.append(leaderType[lvl] + (i+1));
				str.append(" " + leaderType[lvl-1] + t1);
				str.append(" " + leaderType[lvl-1] + t2);
				if ((i == assign-1) && extra) {
					int t3 = 2*i+3;
					str.append(" " + leaderType[lvl-1] + t3 + "\n");
				} else {
					str.append("\n");
				}
			}
			extra = (assign % 2) == 1;
			assign = assign/2;
			lvl++;
		}

		// reached top level of army
		if ((lvl == leaderType.length-1) && (assign > 0)) {
			assignments += 1;
			str.append(leaderType[lvl]);
			for (int i = 0 ; i < assign; i++) {
				int t1 = 2*i+1;
				int t2 = 2*i+2;
				str.append(" " + leaderType[lvl-1] + t1);
				str.append(" " + leaderType[lvl-1] + t2);
			}
			if (extra) {
				int t3 = 2*assign+1;
				str.append(" " + leaderType[lvl-1] + t3 + "\n");
			} else {
				str.append("\n");
			}
		}
		
		System.out.println(assignments);
		System.out.print(str.toString());
	}

	static int koopaType(String s) {
		for (int i = 0; i < numKoopaTypes; i++) {
			if (s.equals(koopaType[i]))
				return i;
		}
		System.err.println("Illegal koopa type: " + s);
		return -1;
	}

	static String koopaName(int t) {
		return koopaType[t];
	}
}
