import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class TryTest  {

	public static void main(String[] args) {
		String [] testNames = { "01", "02", "03", "04", "05", "06" };
		// String [] testNames = { "01","02","03","04","05","06","07","08","09","10" };
		// String [] testNames = { "00", "01","02","03","04","05","06","07","08","09","10","11","12","13"};
		// String [] testNames = { "41","42","43","44","45","46","47","48","49","50","51","52","53"};
		PrintStream out = System.out;
		for (String n : testNames) {
			if (tryTest(n))
				out.println(n + " passed!");
			else 
				out.println(n + " failed!");
		}
	}

	public static boolean tryTest(String testName) {
		try{
			String logName = testName + ".log";
			FileInputStream fin = new FileInputStream(new File(testName + ".in"));
			PrintStream flog = new PrintStream(new FileOutputStream(new File(logName)));
			System.setIn(fin);
			System.setOut(new PrintStream(flog));
			// Problem.main(null);
			Team.main(null);
			return sameContents(logName,testName +".out");

		} catch (Exception e) {
			System.err.println("Caught exception: " + e);
			e.printStackTrace();
			System.err.println();
		}
		return false;
	}

	public static boolean sameContents(String firstFile, String secondFile) throws IOException {
		return (removeBlanks(fileData(firstFile)).equals(removeBlanks(fileData(secondFile))));
	}

	public static String fileData(String fileName) throws IOException {
		StringBuffer stringBuffer = new StringBuffer();
		FileReader fileReader = new FileReader(fileName);
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		Scanner fileScanner = new Scanner(bufferedReader);

		while (fileScanner.hasNextLine())  
			stringBuffer.append(fileScanner.nextLine());

		fileScanner.close();
		return stringBuffer.toString();
	}

	public static String removeBlanks(String src) {
		StringBuffer resultsBuf = new StringBuffer();

		char curr;
		for (int i=0; i<src.length(); i++) {
			curr = src.charAt(i);
			if (curr != ' ' && curr != '\n')
				resultsBuf.append(curr);
		}
		return resultsBuf.toString();
	}


}